# This file is a template, and might need editing before it works on your project.
# This is a sample GitLab CI/CD configuration file that should run without any modifications.
# It demonstrates a basic 3 stage CI/CD pipeline. Instead of real tests or scripts,
# it uses echo commands to simulate the pipeline execution.
#
# A pipeline is composed of independent jobs that run scripts, grouped into stages.
# Stages run in sequential order, but jobs within stages run in parallel.
#
# For more information, see: https://docs.gitlab.com/ee/ci/yaml/index.html#stages
#
# You can copy and paste this template into a new `.gitlab-ci.yml` file.
# You should not add this template to an existing `.gitlab-ci.yml` file by using the `include:` keyword.
#
# To contribute improvements to CI/CD templates, please follow the Development guide at:
# https://docs.gitlab.com/ee/development/cicd/templates.html
# This specific template is located at:
# https://gitlab.com/gitlab-org/gitlab/-/blob/master/lib/gitlab/ci/templates/Getting-Started.gitlab-ci.yml

stages:          # List of stages for jobs, and their order of execution
  - build
  # - deploy
  - archive

build-job:       # This job runs in the build stage, which runs first.
  stage: build
  script:
    - xcodebuild clean -project cicd_demo.xcodeproj -scheme cicd_demo | xcpretty
    - xcodebuild test -project cicd_demo.xcodeproj -scheme cicd_demo -destination 'platform=iOS Simulator,name=iPhone 14,OS=16.2' | xcpretty -s
  tags:
    - ios_12-0
    - xcode_14-2
    - osx_13-1

build-job 2:       # This job runs in the build stage, which runs first.
  stage: build
  script:
    - xcodebuild clean -project cicd_demo.xcodeproj -scheme cicd_demo | xcpretty
    - xcodebuild test -project cicd_demo.xcodeproj -scheme cicd_demo -destination 'platform=iOS Simulator,name=iPhone 14,OS=16.2' | xcpretty -s
  tags:
    - ios_12-0
    - xcode_14-2
    - osx_13-1
# deploy-job:      # This job runs in the deploy stage.
#   stage: deploy  # It only runs when *both* jobs in the test stage complete successfully.
#   environment: production
#   script:
#      - xcodebuild clean -project cicd_demo.xcodeproj -scheme cicd_demo | xcpretty
#      - xcodebuild test -project cicd_demo.xcodeproj -scheme cicd_demo -destination 'platform=iOS Simulator,name=iPhone 14,OS=16.2' | xcpretty -s
#   tags:
#     - ios_12-0
#     - xcode_14-2
#     - osx_13-1

archive_project:
  stage: archive
  script:
    - xcodebuild clean archive -archivePath build/cicd_demo -scheme cicd_demo
    - xcodebuild -exportArchive -archivePath "build/cicd_demo.xcarchive" -exportPath "build/cicd_demo" -exportOptionsPlist ExportOptions.plist
  only:
    - main
  artifacts:
    paths:
      # - build/cicd_demo
    - build/cicd_demo/cicd_demo.ipa
  tags:
    - ios_12-0
    - xcode_14-2
    - osx_13-1
